;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: DelSig_1INT.asm
;;   Version: 1.1, Updated on 2006/06/12 at 14:52:34
;;  Generated by PSoC Designer ver 4.3  b1884 : 23 June, 2006
;;
;;  DESCRIPTION: Assembler interrupt service routine for the Delta-Sigma ADC
;;               User Module based on the Type 2 Decimator. This code works for
;;               both the first and second-order modulator topologies where
;;               the decimation rate requires no extra software shifts.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "DelSig_1.inc"


;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------

export _DelSig_1_ADConversion_ISR
export _DelSig_1_cResult
export  DelSig_1_cResult
export _DelSig_1_bfStatus
export  DelSig_1_bfStatus


;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------
AREA InterruptRAM (RAM, REL, CON)

_DelSig_1_cResult:
 DelSig_1_cResult:                 blk 1             ;ADC output value
_DelSig_1_bfStatus:
 DelSig_1_bfStatus:                blk 1             ;Data Valid Flag


;-----------------------------------------------
;  Private Symbols
;-----------------------------------------------
MSB:                               equ 0
LSB:                               equ 1
RES:                               equ 6
UMAX:                              equ (1<<RES) - 1  ; 2^RES - 1


;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; Includes
;------------------------

;------------------------
; Exports
;------------------------

;------------------------
; Constant Definitions
;------------------------

;------------------------
; Variable Allocation
;------------------------

;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)


AREA UserModules (ROM, REL, CON)

;;=============================================================================
;;  FUNCTION NAME: _DelSig_1_ADConversion_ISR:
;;=============================================================================
;;
_DelSig_1_ADConversion_ISR:
   push  A
   mov   A, reg[DEC_DL]
   cmp   A, UMAX+1                    ; Is value == 2^RES?
   jc    .ConversionReady             ;    No, data is in normal range
   mov   A, UMAX                      ;   Yes, limit to 2^RES - 1

.ConversionReady:
IF DelSig_1_2S_COMPLEMENT
   ; Internal hardware format is unsigned; convert so zero is half scale
   sub   A, (UMAX+1)>>1
ENDIF
   mov [DelSig_1_cResult],  A
   mov [DelSig_1_bfStatus], DelSig_1_DATA_READY_BIT            ; Set valid data flag


   ;@PSoC_UserCode_BODY@ (Do not change this line.)
   ;---------------------------------------------------
   ; Insert your custom code below this banner
   ;---------------------------------------------------


   ;---------------------------------------------------
   ; Insert your custom code above this banner
   ;---------------------------------------------------
   ;@PSoC_UserCode_END@ (Do not change this line.)
   pop   A
   reti

; end of file DelSig_1INT.asm
