//========================================
//==	R}hvZbT		==
//==					==
//========================================

#include <m8c.h>
#include "ctype.h"
#include "cstdef.h"
#include "print.h"
#include "mmc.h"


unsigned char *cmdptr;
unsigned char cmdsts;
const unsigned char *errmsg[] = {	// G[bZ[We[u
	"",
	"?VALUE\r\n",
	"?CMD\r\n",
	"?TIMEOUT\r\n"
};

void skipspace(void)
{
	while(isspace(*cmdptr))
		cmdptr++;
}


//----------------------------------------
//-- '0'`'9'A'A'`'F'0x0`0xFɕϊ	--
//----------------------------------------
unsigned char hexatoi(unsigned char c)
{
	if ((c >= '0') && (c <= '9'))
		return(c - '0');
	if ((c >= 'A') && (c <= 'F'))
		return(c - 'A' + 10);
	if ((c >= 'a') && (c <= 'f'))
		return(c - 'a' + 10);
	return (0);
}

//--------------------------------
//--	16i񌅂̎擾		--
//-- 擪̃[TvX͏ȗ	--
//--------------------------------
unsigned char get2hex()
{
	unsigned char retdat;
	skipspace();
	if (!(isxdigit(*cmdptr))) {	// 擪16iłȂG[I
		cmdsts = E_ERRVAL;
		return(0);
	}
	retdat = hexatoi(*cmdptr++);	// ꌅڂ̎擾
	if (isxdigit(*cmdptr))		// 񌅖ڂΎ擾
		retdat = retdat * 0x10 + hexatoi(*cmdptr++);
	return(retdat);
}

//--------------------------------
//--	16il̎擾		--
//-- 擪̃[TvX͏ȗ	--
//--------------------------------
unsigned int get4hex()
{
	unsigned char	i;
	unsigned int	retdat;
	skipspace();
	if (!(isxdigit(*cmdptr))) {	// 擪16iłȂG[I
		cmdsts = E_ERRVAL;
		return(0);
	}
	retdat = hexatoi(*cmdptr++);	// ꌅڂ̎擾
	for (i=0; i<3; i++) {		// 񌅖ڈȍ~̎擾
		if (!(isxdigit(*cmdptr)))
			break;
		retdat = retdat * 0x10 + hexatoi(*cmdptr++);
	}
	return(retdat);
}

//--------------------------------
//--	10i̎擾		--
//--------------------------------
unsigned int getdeci(void)
{
	unsigned int retdat;
	skipspace();
	if (!(isdigit(*cmdptr))) {	// 擪10iłȂG[I
		cmdsts = E_ERRVAL;
		return(0);
	}
	retdat = (*cmdptr++)-'0';	// ꌅڂ̎擾
	while(isdigit(*cmdptr))	// 񌅖ڈȍ~Ύ擾
		retdat = retdat * 10 + (*cmdptr++) - '0';
	return(retdat);
}


void exec_port(void)
{
	unsigned int	pnum;
	unsigned char	dat;
	pnum = get2hex();
	if (cmdsts != E_READY)
		return;
	skipspace();
	if (*cmdptr == '=') {	// Ȃ珑
		cmdptr++;
		dat = get2hex();
		if (cmdsts != E_READY)
			return;
		switch(pnum) {
			case	0x00:	PRT0DR = dat; break;
			case	0x01:	PRT1DR = dat; break;
			case	0x02:	PRT2DR = dat; break;
			case	0x03:	PRT3DR = dat; break;
			case	0x04:	PRT4DR = dat; break;
			case	0x05:	PRT5DR = dat; break;
			case	0x07:	PRT7DR = dat; break;
			default:	cmdsts = E_ERRVAL; break;
		}
		if (cmdsts == E_READY)
			printf("Write %02X=%02X\n",pnum,dat);
	} else {		// Γǂݍ
		switch(pnum) {
			case	0x00:	dat = PRT0DR; break;
			case	0x01:	dat = PRT1DR; break;
			case	0x02:	dat = PRT2DR; break;
			case	0x03:	dat = PRT3DR; break;
			case	0x04:	dat = PRT4DR; break;
			case	0x05:	dat = PRT5DR; break;
			case	0x07:	dat = PRT7DR; break;
			default:	cmdsts = E_ERRVAL; break;
		}
		if (cmdsts == E_READY)
			printf("Read  %02X:%02X\n",pnum, dat);
	}
}

extern BYTE verbose_mode;
BYTE use_crc = 0;
void exec_help()
{
	printf("Commands:-\n");
	printf("  P : Port Read/Write\n");
	printf("  Z : Reset Command (CMD0 )\n");
	printf("  Y : Ready Check   (CMD1 )\n");
	printf("  S : Read CSD      (CMD9 )\n");
	printf("  I : Read CID      (CMD10)\n");
	printf("  T : Read Status   (CMD13 )\n");
	printf("  O : Read OCR      (CMD58)\n");
	printf("  E : CRC Chk ON/OFF(CMD59) Current = ");
	if (!use_crc) {
		printf("Disable\n");
	} else {
		printf("Enable\n");
	}
	printf("  D : Send Dummy Clk(CS='H') 80 clocks\n");
	printf("  C : Send Command   <ResLen><DatLen><CMD><Par3><Par2><Par1><Par0> \n");
	printf("  R : Read  Sector(CMD11) <Adr3><Adr2><Adr1><Adr0>\n");
	printf("  W : Write Sector(CMD24) <Adr3><Adr2><Adr1><Adr0>{<Dat>}\n");
	printf("  X : Write A-D Data <Adr3><Adr2><Adr1><Adr0>{<Dat>}\n");
	printf("  A : Read A-D Data\n");
	printf("  V : Switch Verbose/Silence (Current Mode=");
	if (verbose_mode)
		printf("'Verbose')\n");
	else	printf("'Silence')\n");
}
//----------------------------------------
//-- R}h̃Gg		--
//----------------------------------------
unsigned char c;
void exec_cmd(unsigned char *s)
{
	cmdsts = E_READY;		// Xe[^XREADYɂĂX^[g
	cmdptr = s;
	skipspace();			// 擪̃Xy[X͍폜
	c = *cmdptr;
	switch(*cmdptr++) {
		case	'P':	exec_port();	// Port Access
				break;
		case	'Z':	exec_reset();
				break;
		case	'Y':	exec_readychk();
				break;
		case	'S':	exec_readcsd();
				break;
		case	'T':	exec_sendstatus();
				break;
		case	'I':	exec_readcid();
				break;
		case	'O':	exec_readocr();
				break;
		case	'E':	exec_crconoff();
				break;
		case	'D':	exec_dummyclk();
				break;
		case	'C':	exec_command();
				break;
		case	'R':	exec_read();
				break;
		case	'W':	exec_write();
				break;
		case	'X':	exec_adwrite();
				break;
		case	'A':	exec_adread();
				break;
		case	'V':	verbose_mode = (verbose_mode & 0x1) ^ 0x01;
				if (verbose_mode)
					printf("Verbose\n");
				else	printf("Silence\n");
				break;
		case	'?':	exec_help();
				break;
		default:	cmdsts = E_ERRCMD;
				break;
	}
	if (cmdsts != E_READY) {
		printf(errmsg[cmdsts]);
		return;
	}
}
