;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: DelSig_1.inc
;;   Version: 1.1, Updated on 2006/06/12 at 14:52:34
;;
;;  DESCRIPTION: Assembler declarations for the Delta-Sigma A/D Converter
;;               with a 1st-order modulator and based on a type 2 decimator.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"

;--------------------------------------------------
; Constants for DelSig_1 API's.
;--------------------------------------------------

DelSig_1_INT_REG:                  equ  0e1h
DelSig_1_INT_MASK:                 equ  08h     ; Interrupt mask

DelSig_1_OFF:                      equ  0
DelSig_1_LOWPOWER:                 equ  1
DelSig_1_MEDPOWER:                 equ  2
DelSig_1_HIGHPOWER:                equ  3

DelSig_1_DATA_READY_BIT:           equ  10h
DelSig_1_2S_COMPLEMENT:            equ  1

;--------------------------------------------------
; Register Address Constants for DelSig_1
;--------------------------------------------------

DelSig_1_PWM_DR0:                  equ 0x2c    ; Period reg
DelSig_1_PWM_DR1:                  equ 0x2d    ; Down count reg
DelSig_1_PWM_DR2:                  equ 0x2e    ; Compare reg
DelSig_1_PWM_CR0:                  equ 0x2f    ; Control reg
DelSig_1_PWM_FN:                   equ 0x2c        ; Function reg
DelSig_1_PWM_SL:                   equ 0x2d        ; Input  select reg
DelSig_1_PWM_OS:                   equ 0x2e        ; Output select reg

DelSig_1_AtoDcr0:                  equ 0x80    ; SC Block Control Reg 0
DelSig_1_AtoDcr1:                  equ 0x81    ; SC Block Control Reg 1
DelSig_1_AtoDcr2:                  equ 0x82    ; SC Block Control Reg 2
DelSig_1_AtoDcr3:                  equ 0x83    ; SC Block Control Reg 3


; end of file DelSig_1.inc
