;;*****************************************************************************
;;  FILENAME: USBFS_1_cls.asm
;;*****************************************************************************

include "m8c.inc"
include "USB_macros.inc"
include "USB.inc"

;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------

AREA bss (RAM,REL)

;-----------------------------------------------
;  Constant Definitions
;-----------------------------------------------
;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------

AREA UserModules (ROM, REL)

;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_Not_Supported
;
;  DESCRIPTION:
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;
;  RETURNS:
;
;  SIDE EFFECTS: REGISTERS ARE VOLATILE: THE A AND X REGISTERS MAY BE MODIFIED!
;
;  THEORY of OPERATION or PROCEDURE:
;
;-----------------------------------------------------------------------------

USBFS_1_cls_Not_Supported:
_USBFS_1_cls_Not_Supported:
   MOV    A, 0                         ; Count 0
   MOV    X, USB_MODE_STALL_IN_OUT     ; Stall the request
   LJMP   USBFS_1_EP0_UPD_MODE_EXIT


;========================================================
;= Get Line Coding̏				=
;=							=
;= bmRequest Type	F 0xA1@@D2H Class Interface	=
;= bRequest		F 0x21				=
;= wValue		F 0x0000@Not Used		=
;= wIndex		F 0x0000@Interface#		=
;= wLength		F 0x07				=
;========================================================
.LITERAL
GetLineCodingTable:
    TD_START_TABLE 1                   ; One entry
    TD_ENTRY    USB_DS_RAM, 7, _line_code, NULL_PTR  ; Intermediate Buffer
.ENDLITERAL

export  USBFS_1_DT_d2h_cls_ifc_Dispatch
USBFS_1_DT_d2h_cls_ifc_Dispatch:
    MOV     [USBFS_1_t2], 0            ; Use the UM temp var--Selector (GetTableEntryŎgFTD_ENTRỶԖڂɂ邩j

    MOV     A,>GetLineCodingTable		; Get the ROM Address MSB
    MOV     X,<GetLineCodingTable		; Get the ROM Address LSB
    JMP     USBFS_1_GetTableEntry_Local_cls

USBFS_1_GetTableEntry_Local_cls:
    LJMP    USBFS_1_GetTableEntry

USBFS_1_NoDataStageControlTransfer_Local_cls:
    LJMP    USBFS_1_NoDataStageControlTransfer


;========================================================
;= Set Line Coding̏				=
;=							=
;= bmRequest Type	F 0x21@@D2H Class Interface	=
;= bRequest		F 0x20				=
;= wValue		F 0x0000@Not Used		=
;= wIndex		F 0x0000@Interface#		=
;= wLength		F 0x07				=
;========================================================
.LITERAL
SetLineCodingTable:
    TD_START_TABLE 1                   ; One entry
    TD_ENTRY    USB_DS_RAM, 7, _line_code, NULL_PTR  ; Intermediate Buffer
.ENDLITERAL
export  USBFS_1_DT_h2d_cls_ifc_Dispatch
USBFS_1_DT_h2d_cls_ifc_Dispatch:
    MOV     [USBFS_1_t2], 0            ; Use the UM temp var--Selector (GetTableEntryŎgFTD_ENTRỶԖڂɂ邩j
    MOV     A,>SetLineCodingTable		; Get the ROM Address MSB
    MOV     X,<SetLineCodingTable		; Get the ROM Address LSB
    JMP     USBFS_1_GetTableEntry_Local_cls

;-----------------------------------------------
; Add custom application code for routines 
; redefined by USB_APP_SUPPLIED in USB_HID.INC
;-----------------------------------------------

   ;@PSoC_UserCode_BODY_1@ (Do not change this line.)
   ;---------------------------------------------------
   ; Insert your custom code below this banner
   ;---------------------------------------------------

   ;---------------------------------------------------
   ; Insert your custom code above this banner
   ;---------------------------------------------------
   ;@PSoC_UserCode_END@ (Do not change this line.)

; End of File USBFS_1_cls.asm
